# 1 Introduction

## 1.1 Background

Machine readable files are efficient ways to specify protocols and data structures for Stage 3 standardization activities

A general term for such files (also according to ETSI Directives) is **software\***, i.e. formal definitions in some specific syntax and semantics (e.g. OpenAPI, TOSCA, YANG, etc.).

The publication of such files in Standards does not constrain implementations to make use of them for the implementation. They provide a precise definition of the expected behavior as seen from an external entity, independently from the way such behavior is implemented.

Development, coordination, governance and publication practices vary among standardization groups.

Software included in the deliverable, attached as part of a ZIP archive, referenced from a different location

Coordination techniques include Word change tracking, email, Version Control Systems, etc.

\* *The definition of the term “software” is found in the ETSI Directives v40, Annex 6, definition number 14.*

## 1.2 Scope of the document

This document contains the description of a process to manage contributions to ETSI deliverables via the ETSI Forge platform.

## 1.3 Key aspects

The key aspects of the process presented here are the following:

1. Machine readable definitions (i.e. software) are developed (i.e. contributed and edited) primarily using GIT repositories at ETSI Forge, then incorporated or referenced in the deliverables;
2. Changes in the repository are univocally  to contributions on ETSI Portal;
3. Each change in the repository may be tracked by a unique contribution, which holds the status in the approval process; a contribution on the ETSI Portal may reference more than one changes in the repository;
4. Each version of the content of the repository to be included or referenced in an ETSI deliverable is identified by a URL, by means of Git `tags` and/or `branches`;
5. Discussion and consensus building may happen offline w.r.t. meetings, especially when dealing with editorials and minor changes;
6. Software may be post-processed, embedded or referenced into the deliverables **after** the changes are approved;

