## 2 Contributions process to deliverables from ETSI Forge

### 2.1 Overview of the process

The steps below describe the process for contribution and integration of machine readable content hosted on ETSI Forge repositories.

#### 1.  Reserve contribution 

> OPTIONAL 

The contributor reserves a contribution number on the ETSI Portal related to the TB/ISG and WI of interest, so that it can be included in the preparation of the Merge Request.

#### 2. Submit changes

The **contributor** uploads a set of changes (either modifications or additions) to the repository on the ETSI Forge.

This activity can be executed in several ways:

*  Via the web interface of Gitlab (either the "Edit" button or the "Web IDE"), or
*  Via Git (by using a Git client locally).

#### 3. Submit a merge request

The **contributor** creates and submits a new Merge Request in the approprate repository on the Forge Platform.

  - The submitted Merge Request **shall** include:
    - The changes uploaded to a branch in the repository, marked with a **given temporary name** (e.g. a `branch` or `tag` to uniquely identify the changes),
    - Motivation, rationale or purpose of the changes, and 
    - the description of changes;
  - The submitted Merge Request **may** include:
    - a reserved contribution number,
    - a link to a discussion or open issue in either the Forge Bugzilla bug tracker or in the integrated Gitlab bug tracker.

See clause 3 Templates for a template of a Merge Request.

#### 4. Post comment

#### 5. Resolve comments

#### 6. Proceed to contribution

#### 7. Flag MR as Ready

#### 8. Submit or revise Contribution

Contributor prepares and makes available a contribution on the Portal.

  - The submitted contribution shall include:
    - Link to the Merge Request
    - Reference in the text to the location of the changed software, i.e. the changes in the target deliverable which include the links to the new version of the software in the named branch linked to the MR
      EXAMPLE: Merge request XYZ proposes to merge branch FEAT1 into branch v1.1.x and is to be approved in contribution (19)00000ABC. The contribution will contain the changes in the base deliverable with the URLs updated to point to forge.etsi.org/rep/TB/DOCNUM/tree/FEAT1
      b.	It may include
      i.	The tag to be applied after the MR is merged
      ii.	Changes to other elements of the deliverable (e.g. textual descriptions, tables, figures, etc.) required to maintain consistency with the changes proposed in the Merge Request.

#### 9. Contribution approval process is held leading to the approval of the contribution on the Portal;

a.	If the proposed changes need revisions – either due to email discussion , or discussion during a meeting – the software on the Forge will be changed first (generating a new version) and the related contribution needs to be revised to include the pointer to the latest changes. 

#### 10. Provide comment

#### 11. Note contribution

#### 12. Reject contribution

#### 13. Declare contribution approved

#### 14. Close MR request

#### 15. The rapporteur merges the Merge request(s?) related to the approved contributions.

a.	NOTE: this activity may be automatized in the future but needs to take into the account the possibility of conflicts thus requiring manual intervention.

#### 16. New draft needed

#### 17. Rapporteur applies the appropriate tag to the repository

a.	With the version number of the Draft deliverable that will reference the tag
b.	Note: This may be automatized

#### 18. Rapporteur updates the draft of the deliverable

a.	All temporary links replaced with the link to the tagged version;
b.	The other elements in the approved contributions are incorporated as well, as usual.

#### 19. Upload draft

#### 20. ETSI Secretariat receives the final draft ready for publication;

#### 21. ETSI Secretariat finalizes the repository, applies the publication tag and finalizes the document.

Checklist before applying the tag:

* Is the LICENSE file present and does it contain correct license?
* Is a README file present? If yes, does it contain the correct information (e.g. version numbers, releases, links to WIs, etc.)
* Check with the Rapporteur and TB official if there is anything else that needs to be added or modified in the repository before applying the tag

To apply the tag, use the following information:

* The tag label should be in the form "vX.Y.Z" where X Y and Z are the three version numbers
  * Example: `v1.1.1`
* The tag commit messages should describe the content of the repository and the related version of the WI
  * Example (fictional): `ASN.1 definitions for version 1.1.1 of ETSI 103  999`
* The release notes may contain any other information to link to the published documents
  * Example: `More information and Standard downloads at https://portal.etsi.org/webapp/WorkProgram/Report_WorkItem.asp?WKI_ID=53615`
  * *Note: the release notes may be changed after the tag creation, while the commit message cannot be changed without deleting and recreating the tag itself.*

### Overview of the process

A diagram showing the tasks in the process and their relations is available in the picture below.

![Proposed process](imgs/overall-process.png "Proposed process")